import BN from 'bn.js';
import { PublicKey, TransactionInstruction } from '@solana/web3.js';
import { Order } from '@project-serum/serum/lib/market';
export declare function makeCancelOrderInstruction(programId: PublicKey, mangoGroupPk: PublicKey, ownerPk: PublicKey, marginAccountPk: PublicKey, dexProgramId: PublicKey, spotMarketPk: PublicKey, bidsPk: PublicKey, asksPk: PublicKey, openOrdersPk: PublicKey, signerKey: PublicKey, eventQueuePk: PublicKey, order: Order): TransactionInstruction;
export declare function makeSettleFundsInstruction(programId: PublicKey, mangoGroupPk: PublicKey, ownerPk: PublicKey, marginAccountPk: PublicKey, dexProgramId: PublicKey, spotMarketPk: PublicKey, openOrdersPk: PublicKey, signerKey: PublicKey, spotMarketBaseVaultPk: PublicKey, spotMarketQuoteVaultPk: PublicKey, mangoBaseVaultPk: PublicKey, mangoQuoteVaultPk: PublicKey, dexSignerKey: PublicKey): TransactionInstruction;
export declare function makeBorrowInstruction(programId: PublicKey, mangoGroupPk: PublicKey, marginAccountPk: PublicKey, walletPk: PublicKey, tokenIndex: number, openOrders: PublicKey[], oracles: PublicKey[], nativeQuantity: BN): TransactionInstruction;
export declare function makeWithdrawInstruction(programId: PublicKey, mangoGroupPk: PublicKey, marginAccountPk: PublicKey, walletPk: PublicKey, signerKey: PublicKey, tokenAccPk: PublicKey, vaultPk: PublicKey, openOrders: PublicKey[], oracles: PublicKey[], nativeQuantity: BN): TransactionInstruction;
export declare function makeSettleBorrowInstruction(programId: PublicKey, mangoGroupPk: PublicKey, marginAccountPk: PublicKey, walletPk: PublicKey, tokenIndex: number, nativeQuantity: BN): TransactionInstruction;
export declare function makeForceCancelOrdersInstruction(programId: PublicKey, mangoGroup: PublicKey, liqor: PublicKey, liqeeMarginAccount: PublicKey, baseVault: PublicKey, quoteVault: PublicKey, spotMarket: PublicKey, bids: PublicKey, asks: PublicKey, signerKey: PublicKey, dexEventQueue: PublicKey, dexBaseVault: PublicKey, dexQuoteVault: PublicKey, dexSigner: PublicKey, dexProgramId: PublicKey, openOrders: PublicKey[], oracles: PublicKey[], limit: BN): TransactionInstruction;
export declare function makePartialLiquidateInstruction(programId: PublicKey, mangoGroup: PublicKey, liqor: PublicKey, liqorInTokenWallet: PublicKey, liqorOutTokenWallet: PublicKey, liqeeMarginAccount: PublicKey, inTokenVault: PublicKey, outTokenVault: PublicKey, signerKey: PublicKey, openOrders: PublicKey[], oracles: PublicKey[], maxDeposit: BN): TransactionInstruction;
export declare function makeAddMarginAccountInfoInstruction(programId: PublicKey, mangoGroup: PublicKey, marginAccount: PublicKey, owner: PublicKey, info: string): TransactionInstruction;
//# sourceMappingURL=instruction.d.ts.map