"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const serum_1 = require("@project-serum/serum");
const web3_js_1 = require("@solana/web3.js");
const os = __importStar(require("os"));
const fs = __importStar(require("fs"));
const client_1 = require("./client");
const ids_json_1 = __importDefault(require("./ids.json"));
const utils_1 = require("./utils");
const layout_1 = require("./layout");
async function tests() {
    const cluster = "mainnet-beta";
    const client = new client_1.MangoClient();
    const clusterIds = ids_json_1.default[cluster];
    const connection = new web3_js_1.Connection(ids_json_1.default.cluster_urls[cluster], 'processed');
    const mangoGroupPk = new web3_js_1.PublicKey(clusterIds.mango_groups['BTC_ETH_SOL_SRM_USDC'].mango_group_pk);
    const mangoProgramId = new web3_js_1.PublicKey(clusterIds.mango_program_id);
    const keyPairPath = process.env.KEYPAIR || os.homedir() + '/.config/solana/id.json';
    const payer = new web3_js_1.Account(JSON.parse(fs.readFileSync(keyPairPath, 'utf-8')));
    /*
    async function testSolink() {
  
      const oraclePk = new PublicKey(IDS[cluster].oracles['ETH/USDT'])
      const agg = await Aggregator.loadWithConnection(oraclePk, connection)
  
      // const agg = await Aggregator.loadWithConnection(oraclePk, connection)
      console.log(agg.answer.median.toNumber(), agg.answer.updatedAt.toNumber(), agg.round.id.toNumber())
  
    }
    */
    /*
    async function testDepositSrm() {
      const srmVaultPk = new PublicKey(clusterIds['mango_groups']['BTC_ETH_USDT']['srm_vault_pk'])
      const mangoGroup = await client.getMangoGroup(connection, mangoGroupPk, srmVaultPk)
      const srmAccountPk = new PublicKey("6utvndL8EEjpwK5QVtguErncQEPVbkuyABmXu6FeygeV")
      const mangoSrmAccountPk = await client.depositSrm(connection, mangoProgramId, mangoGroup, payer, srmAccountPk, 100)
      console.log(mangoSrmAccountPk.toBase58())
      await sleep(2000)
      const mangoSrmAccount = await client.getMangoSrmAccount(connection, mangoSrmAccountPk)
      const txid = await client.withdrawSrm(connection, mangoProgramId, mangoGroup, mangoSrmAccount, payer, srmAccountPk, 50)
      console.log('success', txid)
    }
    */
    async function getMarginAccountDetails() {
        const mangoGroup = await client.getMangoGroup(connection, mangoGroupPk);
        const marginAccountPk = new web3_js_1.PublicKey("AoqCcazWgh1VyDhDmvUEt36UHKt3ujJv57c9YEvaDZLj");
        const marginAccount = await client.getMarginAccount(connection, marginAccountPk, mangoGroup.dexProgramId);
        const prices = await mangoGroup.getPrices(connection);
        console.log(marginAccount.toPrettyString(mangoGroup, prices));
        console.log(marginAccount.beingLiquidated);
        console.log(marginAccount.getCollateralRatio(mangoGroup, prices));
        for (let i = 0; i < layout_1.NUM_TOKENS; i++) {
            console.log(marginAccount.getUiDeposit(mangoGroup, i), marginAccount.getUiBorrow(mangoGroup, i));
        }
        for (let i = 0; i < layout_1.NUM_MARKETS; i++) {
            let openOrdersAccount = marginAccount.openOrdersAccounts[i];
            if (openOrdersAccount === undefined) {
                continue;
            }
            console.log('referrer rebates', i, openOrdersAccount['referrerRebatesAccrued'].toNumber());
            console.log(i, utils_1.nativeToUi(openOrdersAccount.quoteTokenTotal.toNumber() + openOrdersAccount['referrerRebatesAccrued'].toNumber(), mangoGroup.mintDecimals[layout_1.NUM_MARKETS]), utils_1.nativeToUi(openOrdersAccount.quoteTokenFree.toNumber(), mangoGroup.mintDecimals[layout_1.NUM_MARKETS]), utils_1.nativeToUi(openOrdersAccount.baseTokenTotal.toNumber(), mangoGroup.mintDecimals[i]), utils_1.nativeToUi(openOrdersAccount.baseTokenFree.toNumber(), mangoGroup.mintDecimals[i]));
        }
    }
    async function testMarketOrderDex() {
        const NUM_MARKETS = 2;
        const dexProgramId = new web3_js_1.PublicKey(clusterIds.dex_program_id);
        const mangoGroup = await client.getMangoGroup(connection, mangoGroupPk);
        // load largest wallet account for each token
        const tokenWallets = (await Promise.all(mangoGroup.tokens.map((mint) => utils_1.findLargestTokenAccountForOwner(connection, payer.publicKey, mint).then((response) => response.publicKey))));
        console.log({ tokenWallets: tokenWallets.map(w => w.toString()) });
        // load all markets
        const markets = await Promise.all(mangoGroup.spotMarkets.map((pk) => serum_1.Market.load(connection, pk, { skipPreflight: true, commitment: 'singleGossip' }, dexProgramId)));
        console.log({ markets });
        // load open orders
        const liqorOpenOrdersKeys = [];
        for (let i = 0; i < NUM_MARKETS; i++) {
            let openOrdersAccounts = await markets[i].findOpenOrdersAccountsForOwner(connection, payer.publicKey);
            if (openOrdersAccounts.length) {
                liqorOpenOrdersKeys.push(openOrdersAccounts[0].publicKey);
            }
            else {
                console.log(`No OpenOrders account found for market ${markets[i].publicKey.toBase58()}`);
            }
        }
        console.log({ liqorOpenOrdersKeys: liqorOpenOrdersKeys.map(k => k.toString()) });
        const marketIndex = 1;
        const market = markets[marketIndex]; // ETH/USDT
        const price = 4000;
        const size = 0.001;
        const txid = await market.placeOrder(connection, {
            owner: payer,
            payer: tokenWallets[marketIndex],
            side: 'sell',
            price,
            size,
            orderType: 'ioc',
            openOrdersAddressKey: liqorOpenOrdersKeys[marketIndex],
            feeDiscountPubkey: null // TODO find liqor's SRM fee account
        });
        console.log({ txid });
        var lastSeenSeqNum = undefined;
        for (let i = 0; i < 50; ++i) {
            const status = await connection.getSignatureStatus(txid);
            console.log({ status: status.value.confirmations });
            let orders = await market.loadOrdersForOwner(connection, payer.publicKey);
            console.log({ orders });
            const info = await connection.getAccountInfo(market['_decoded'].eventQueue);
            const { header, nodes } = utils_1.decodeRecentEvents(info.data, lastSeenSeqNum);
            console.log({ header, nodes: nodes.map(n => [n.nativeQuantityPaid.toNumber(),
                    n.nativeQuantityReleased.toNumber()]) });
            lastSeenSeqNum = header.seqNum;
            const liqorWalletAccounts = await utils_1.getMultipleAccounts(connection, tokenWallets, 'processed');
            const liqorValuesUi = liqorWalletAccounts.map((a, i) => utils_1.nativeToUi(utils_1.parseTokenAccountData(a.accountInfo.data).amount, mangoGroup.mintDecimals[i]));
            console.log({ liqorValuesUi });
            await utils_1.sleep(500);
        }
    }
    await getMarginAccountDetails();
    // await testSolink()
    // await testDepositSrm()
    // await testMarketOrderDex()
}
tests();
//# sourceMappingURL=tests.js.map